platform = {}

-- All platforms --
local plats = {}

function platform.add(type, pos, wdt, hgt)

    plat = {

        ['type'] = type,
        ['lt_w'] = pos.x - 8,
        ['rt_w'] = pos.x + wdt,

        ['fr_w'] = pos.y - 8,
        ['rf_w'] = pos.y + hgt}

    table.insert(plats, #plats, plat)
end

function platform.col(vect, coll, down)

    -- Check every platform --
    for l = 0, #plats do

        -- Check if character is between walls of platform --
        if vect.x >= plats[l].lt_w and vect.x <= plats[l].rt_w then

            -- Returns Floor --
            if vect.y <= plats[l].fr_w and vect.y >= plats[l].fr_w - 6 then

                if plats[l].type == "solid" then coll.dw = plats[l].fr_w end
                if plats[l].type == "jthru" and not down then coll.dw = plats[l].fr_w end
            end

            -- Returns Roof --
            if vect.y >= plats[l].rf_w and vect.y <= plats[l].rf_w + 6 then

                if plats[l].type == "solid" then coll.up = plats[l].rf_w end
                if plats[l].type == "jthru" then coll.up = 0 end
            end
        end

        -- Check if character is between floor and roof --
        if vect.y > plats[l].fr_w and vect.y < plats[l].rf_w then
            
            -- Returns wall in left --
            if vect.x <= plats[l].lt_w and vect.x >= plats[l].lt_w - 6 then coll.rt = plats[l].lt_w end

            -- Returns wall in right --
            if vect.x >= plats[l].rt_w and vect.x <= plats[l].rt_w + 6 then coll.lt = plats[l].rt_w end
        end
    end
end

function platform:push(pos)

    sys.debug({pos.x, pos.y})

    -- Check every platform --
    for l = 0, #plats do

        if pos.y > plats[l].fr_w and pos.y > plats[l].rf_w then
            
            -- overlapping on left --
            if pos.x > plats[l].lt_w and pos.x < plats[l].rt_w - 4 then pos.x = plats[l].lt_w end
            
            -- overlapping on right --
            if pos.x < plats[l].rt_w and pos.x > plats[l].rt_w + 4 then pos.x = plats[l].rt_w end
        end
    end
end

function platform.del(name)

    if name then plats[name] = nil
    else plats = {} end
end

function platform.drw()

    for plat in pairs(plats) do
    
        love.graphics.rectangle('fill', plats[plat].lt_w + 8, plats[plat].fr_w + 8, 8, 8)
    end
end