textbox = {}

local random_offset = vector2d(0, 0)

function textbox.type(data, speed, ypos, trigger, tgrTime)

    this = {

        -- Dramatic Pause --
        ['tgr'] = trigger,
        ['tTm'] = tgrTime,

        -- Printing paramters --
        ['msg'] = data,
        ['pos'] = vector2d(0, ypos),
        ['cps'] = speed,
        ['speed'] = speed,
        ['timer'] = 1 / speed,
        ['ctext'] = '',

        ['ended'] = false
    }

    return this
end

function textbox.write(dt, text)

    -- Set random offset --
    random_offset.x = math.random(0, 24)
    random_offset.y = math.random(0, 24)

    -- Dramatic Waiting --
    if text.tgr and sys.finds(text.tgr, #text.ctext) then text.cps = text.tTm
    else text.cps = text.speed end

    -- Set the midle position --
    text.pos.x = (wdth / 2) - ((#text.ctext * 12) / 2)

    -- If isn't too slow --
    if dt > 0.035 then return end

    text.timer = text.timer - dt

    -- Show Text --
    if text.timer <= 0 then

        text.timer = 1 / text.cps
        if text.ctext ~= text.msg then text.ctext = text.ctext .. text.msg:sub(#text.ctext + 1, #text.ctext + 1)
        else text.ended = true end
        
        -- Text sound --
        -- none --
    end
end

function textbox.draw(text, effect)

    local r, g, b, a = love.graphics.getColor()

    for t in pairs(text) do

        this = text[t]

        if effect == 'noises' then

            love.graphics.setColor(0, 0, 1, 0.5)
            love.graphics.print(this.ctext, this.pos.x + (random_offset.x / 12), this.pos.y)

            love.graphics.setColor(1, 0, 0, 0.5)
            love.graphics.print(this.ctext, this.pos.x - (random_offset.y / 12), this.pos.y)
        end

        if effect == 'glitch' then end

        love.graphics.setColor(1, 1, 1, 1)
        love.graphics.print(this.ctext, this.pos.x, this.pos.y)
    end

    love.graphics.setColor(r, g, b, a)
end

return textbox