map = {}

local block = {}
local solid = {}
local decor = {}

function block:load()

    local other = {}

    setmetatable(other, self)
    self.__index = self

    return other
end

function block:init(pos, spr)

    self.bpos = pos
    self.sprt = spr
end

function block:draw()

    love.graphics.draw(sres.tiled, self.sprt, self.bpos.x, self.bpos.y)
end

function map.tmap(data, addt, _dict, _thru, _skip)

    solid = {}
    decor = {}

    platform.del()

    -- For every line in the map --
    for line in pairs(data) do

        -- Split tiles --
        splitd = sys.split(data[line], ' ')

        -- For every tile in splited line --
        for tile in pairs(splitd) do

            -- Get sprite in the _dictionary --
            this = _dict[splitd[tile]]

            -- Set position and draw quad --
            tpos = vector2d((tile - 1) * 8, line * 8)
            sprt = love.graphics.newQuad(this.x * 8, this.y * 8, 8, 8, sres.tiled:getDimensions())
            
            -- Load block object --
            table.insert(solid, block:load())

-- # Configure the block --------------------------------- # --
            
            -- Non solid block --
            if sys.finds(_skip, splitd[tile]) then
                
                solid[#solid]:init(tpos, sprt)

            -- Jump _thru platform --
            elseif sys.finds(_thru, splitd[tile]) then

                solid[#solid]:init(tpos, sprt)
                platform.add('jthru', tpos, 8, 8)
            
            -- Solid block --
            else

                solid[#solid]:init(tpos, sprt)
                platform.add('solid', tpos, 8, 8)
            end
        end
    end

-- # Additional tiles ------------------------------------ # --

    -- For every line in the map --
    for line in pairs(addt) do

        -- Split tiles --
        splitd = sys.split(addt[line], ' ')

        -- For every tile in splited line --
        for tile in pairs(splitd) do

            -- Get sprite in the _dictionary --
            this = _dict[splitd[tile]]

            -- Set position and draw quad --
            tpos = vector2d((tile - 1) * 8, line * 8)
            sprt = love.graphics.newQuad(this.x * 8, this.y * 8, 8, 8, sres.tiled:getDimensions())
            
            -- Add block --
            table.insert(decor, block:load())
            decor[#decor]:init(tpos, sprt)
        end
    end
end

function map.draw()

    -- Draw each block --
    for indx, blk in pairs(solid) do

        blk:draw()
    end

    for indx, blk in pairs(decor) do

        blk:draw()
    end
end