rend = {}

function rend:load()

    local other = {}

    setmetatable(other, self)
    self.__index = self

    return other
end

function rend:init(frame)

    -- Time ctrl --
    self.aFps = 0
    self.timr = 1 / self.aFps

    -- Initidal frame --
    self.reload = false
    if not frame then frame = vector2d(0, 0) end

    -- Open and store data to animate --
    self.quad = love.graphics.newQuad(frame.x * 8, frame.y * 8, 8, 8, sres.sheet:getDimensions())
end

function rend:play(dt, anim, frames, speed, loop)
    
    -- Reset to a new animation --
    if self.aFps ~= speed then self.reload = true end
    if self.reload then

        self.aFps = speed
        self.timr = 1 / self.aFps

        self.cFrm = frames[0]
        self.nfrm = -1

        -- Set the first frame --
        self.quad:setViewport(self.cFrm * 8, anim * 8, 8, 8)

        self.reload = false
    end

    -- Wait if is too slow --
    if dt > 0.035 then return end

    -- Wait for next frame --
    self.timr = self.timr - dt

    -- No time left --
    if self.timr <= 0 then
        
        -- Reset timer --
        self.timr = 1 / self.aFps

        self.nfrm = self.nfrm + 1

        -- For Loop --
        if self.nfrm > #frames and loop then self.nfrm = 0 end
        if self.nfrm > #frames and not loop then return true end

        -- Next frame --
        self.cFrm = frames[self.nfrm]

        -- Update frame --
        self.quad:setViewport(self.cFrm * 8, anim * 8, 8, 8)
    end
end

function rend:loop()

    self.reload = true
end

function rend:draw(pos, side)

    if side > 0 then love.graphics.draw(sres.sheet, self.quad, pos.x, pos.y, 0, 1, 1) end
    if side < 0 then love.graphics.draw(sres.sheet, self.quad, pos.x + 8, pos.y, 0, -1, 1) end
end