room = {}

room.rid = 0
room.out = false

local logo = false
local fade = true

local wait = false
local othr = 0
local timr = 0

local about_ = false

function room.load()

    -- Load png's --
    source = love.graphics.newImage("start_screen.png")
    credit = love.graphics.newImage("credits_file.png")
    bblogo = love.graphics.newImage("binarybrain_.png")

    whiteS = love.graphics.newQuad(0, 0, 160, 160, source:getDimensions())
    whiteS:setViewport(160, 0, 160, 160)

    blackS = love.graphics.newQuad(0, 0, 160, 160, source:getDimensions())
    blackS:setViewport(0, 0, 160, 160)
end

function room.update(dt)

    -- Wait bblogo --
    if logo == false then

        -- Default time --
        othr = othr + 200 * dt
        
        -- Fade time --
        if othr > 255 then timr = timr + 200 * dt end
        
        -- End of fade --
        if timr > 255 then
            
            timr = 0

            logo = true
            fade = false
        end
    end

    -- Fade out --
    if fade == false then

        wait = true
        timr = timr + 200 * dt 
            
        if timr > 255 then
            
            wait = false
            fade = true
        end
    end
end

function room.keypressed(key)

    -- Start --
    if key == "x" and logo and fade and not about_ then room.out = true end
    if key == "c" and logo and fade then about_ = not about_ end
end

function room.draw()

    -- Start Screen --
    if not about_ then

        if random == 2 then love.graphics.draw(source, blackS, 0, 0)
        else love.graphics.draw(source, whiteS, 0, 0) end
    
    else
        
        if random == 2 then love.graphics.draw(credit, blackS, 0, 0)
        else love.graphics.draw(credit, whiteS, 0, 0) end
    end

    -- Draw bblogo --
    if logo == false then

        love.graphics.draw(bblogo, 0, 0)

        local r, g, b, a = love.graphics.getColor()
        
        love.graphics.setColor(1, 1, 1, timr / 255)
        love.graphics.rectangle("fill", 0, 0, 160, 160)
        love.graphics.setColor(r, g, b, a)
    end

    -- Transition --
    if wait then

        local r, g, b, a = love.graphics.getColor()
        
        love.graphics.setColor(1, 1, 1, (255 - timr) / 255)
        love.graphics.rectangle("fill", 0, 0, 160, 160)
		love.graphics.setColor(r, g, b, a)
    end
end

return room